unit frmKvalifikace_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmKvalifikace = class(TForm)
    btnZavrit: TButton;
    lblNadpis: TLabel;
    pnlPodklad: TPanel;
    rdgPracovnici: TRadioGroup;
    grbStroje: TGroupBox;
    chbSoustruh: TCheckBox;
    chbHorizontka: TCheckBox;
    chbVrtacka: TCheckBox;
    chbHoblovka: TCheckBox;
    chbBruska: TCheckBox;
    chbLaser1: TCheckBox;
    chbLaser2: TCheckBox;
    chbTrumatic: TCheckBox;
    chbV_nuzky: TCheckBox;
    chbM_nuzky: TCheckBox;
    btnPotvrdit: TButton;
    btnVratit: TButton;
    btnUlozit: TButton;
    btnPrehled: TButton;
    svdUlozSoubor: TSaveDialog;
    procedure btnZavritClick(Sender: TObject);
    procedure rdgPracovniciClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnVratitClick(Sender: TObject);
    procedure btnPotvrditClick(Sender: TObject);
    procedure btnUlozitClick(Sender: TObject);
    procedure btnPrehledClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmKvalifikace: TfrmKvalifikace;

implementation

{$R *.dfm}

type
  kompetence = ARRAY[0..20,0..20] of tCheckBoxState;

var
  CanWork : kompetence;
  f       : file of kompetence;

procedure TfrmKvalifikace.btnPotvrditClick(Sender: TObject);
var
  i,j,MaxStroj: smallInt;

begin
  i := frmKvalifikace.rdgPracovnici.ItemIndex;//index pracovnika
  MaxStroj := frmKvalifikace.grbStroje.ControlCount;
  for j := 0 to MaxStroj - 1 do
    CanWork[i,j] := (frmKvalifikace.grbStroje.Controls[j] as tcheckbox).State;

  frmKvalifikace.grbStroje.Enabled    := false;
  frmKvalifikace.btnPotvrdit.Enabled  := false;
  frmKvalifikace.btnVratit.Enabled    := false;
  frmKvalifikace.btnUlozit.Enabled    := true;

end;

procedure TfrmKvalifikace.btnPrehledClick(Sender: TObject);
var
  appPath, VystSoubor : string;
  t : textfile;
  i, MaxStroj : smallint;
begin
  MaxStroj := frmKvalifikace.grbStroje.ControlCount;

  GetDir(0,appPath);
  frmKvalifikace.svdUlozSoubor.InitialDir := appPath;

  if frmKvalifikace.svdUlozSoubor.Execute then
    VystSoubor := frmKvalifikace.svdUlozSoubor.FileName
  else exit;

  assignfile(t,VystSoubor);
  rewrite(t);

  write(t,'':20);

  for i := 0 to MaxStroj - 1 do
    write(t,copy((frmKvalifikace.grbStroje.Controls[i] as tcheckbox).Name,4,6),' ');
  writeln(t);
  for i := 1 to 20 + (6+1)* MaxStroj do
    write(t,'=');


  closefile(t);
end;

procedure TfrmKvalifikace.btnUlozitClick(Sender: TObject);
begin
  rewrite(f);
  write(f,CanWork);
  closefile(f);
  frmKvalifikace.btnUlozit.Enabled    := false;
end;

procedure TfrmKvalifikace.btnVratitClick(Sender: TObject);
var
  i,j,MaxStroj: smallInt;

begin
  i := frmKvalifikace.rdgPracovnici.ItemIndex;//index pracovnika
  MaxStroj := frmKvalifikace.grbStroje.ControlCount;
  for j := 0 to MaxStroj - 1 do
    (frmKvalifikace.grbStroje.Controls[j] as tcheckbox).State := CanWork[i,j];
end;

procedure TfrmKvalifikace.btnZavritClick(Sender: TObject);
begin
  close;
end;

procedure TfrmKvalifikace.FormCreate(Sender: TObject);
var
  i,j: smallInt;
  MaxStroj, MaxPrac : smallInt;

begin
  assignfile(f,'kvalifikace.hid');
  {$i-}
  reset(f);
  {$i+}
  if IOResult <> 0 then
  begin
    //soubor neexistuje
    ShowMessage('Soubor s kompetencemi neexistuje');
    MaxPrac := frmKvalifikace.rdgPracovnici.ControlCount;
    MaxStroj := frmKvalifikace.grbStroje.ControlCount;
    for I := 0 to MaxPrac - 1 do
      for j := 0 to MaxStroj - 1 do
        CanWork[i,j] := cbUnchecked;
  end
  else
  begin
    //soubor existuje
    read(f,CanWork);
    closefile(f);
  end;
end;

procedure TfrmKvalifikace.rdgPracovniciClick(Sender: TObject);
var
  i,j,MaxStroj: smallInt;

begin
  i := frmKvalifikace.rdgPracovnici.ItemIndex;//index pracovnika
  MaxStroj := frmKvalifikace.grbStroje.ControlCount;
  for j := 0 to MaxStroj - 1 do
    (frmKvalifikace.grbStroje.Controls[j] as tcheckbox).State := CanWork[i,j];

  frmKvalifikace.grbStroje.Enabled    := true;
  frmKvalifikace.btnPotvrdit.Enabled  := true;
  frmKvalifikace.btnVratit.Enabled    := true;
//  frmKvalifikace.btnUlozit.Enabled    := false;

end;

end.
